%define origversion 2.0-16

Summary:   Libsafe: Protecting Critical Elements of Stacks
Name:      libsafe
Version:   2.0.16
Release:   alt2
Copyright: LGPL
Group:     System/Libraries
Source:    http://www.research.avayalabs.com/project/libsafe/%{name}-%{origversion}.tgz
URL:       http://www.research.avayalabs.com/project/libsafe/index.html
Conflicts: libsafe-prelude

# Automatically added by buildreq on Sun May 18 2003
BuildRequires: libssl-devel

%description
The libsafe library protects a process against the exploitation of
buffer overflow vulnerabilities in process stacks. Libsafe works with
any existing pre-compiled executable and can be used transparently,
even on a system-wide basis. The method intercepts all calls to
library functions that are known to be vulnerable. A substitute
version of the corresponding function implements the original
functionality, but in a manner that ensures that any buffer overflows
are contained within the current stack frame. Libsafe has been shown
to detect several known attacks and can potentially prevent yet
unknown attacks. Experiments indicate that the performance overhead of
libsafe is negligible.

%description -l ru_RU.KOI8-R
 libsafe     
   . Libsafe   
     , 
 .     
  .   
     , 
,       
   . Libsafe    
       
 .   ,   libsafe
   .

,   ,   
%_defaultdocdir/%name-%version

     libprelude.

%description -l uk_UA.KOI8-U
̦ libsafe    Ԧ 
   . Libsafe   - Ц
   դ ,  ҦΦ
. ̦ դ  Ӧ צ 
¦̦ æ. ͦ צצϧ æ դ Ǧ
æΦ  Ԧ Φ,  դ,  -˦
 Ҧ  ͦΦ    
. Libsafe      צ 
  æ  צͦ.  , 
 libsafe    ˦  .

-,   æ,  ͦ 
%_defaultdocdir/%name-%version

  ڦ  Ц libprelude.

%prep
%setup -q -n %name-%origversion

%build
%__subst 's/^\(LIBPRELUDE_LIBS = \).*/\1/gi' src/Makefile
%__subst 's/^\(LIBPRELUDE_CFLAGS = \).*/\1/gi' src/Makefile
%make

%install
%__mkdir_p $RPM_BUILD_ROOT/%_lib
%__mkdir_p $RPM_BUILD_ROOT/%_man8dir
%__install -m 755 src/%name.so.%version $RPM_BUILD_ROOT/%_lib/
%__install -m 644 doc/%name.8 $RPM_BUILD_ROOT/%_man8dir/
pushd $RPM_BUILD_ROOT/%_lib
%__ln_s -f %name.so.%version %name.so.2
popd

%files
%doc README EMAIL_NOTIFICATION LIBPRELUDE COPYING ChangeLog INSTALL doc exploits
/%_lib/%name.so.2
/%_lib/%name.so.%version
%_man8dir/%{name}*

%post
if [ -f %_sysconfdir/ld.so.preload ]; then
    tmpfile=`mktemp -t %name.XXXXXX` || exit 1
    if %__grep -q %name %_sysconfdir/ld.so.preload 2>/dev/null; then
        /bin/echo "Updating path to %name in %_sysconfdir/ld.so.preload"
        %__cp %_sysconfdir/ld.so.preload $tmpfile
        %__grep -v %name $tmpfile > %_sysconfdir/ld.so.preload
        /bin/echo %_lib/%name.so.2 >> %_sysconfdir/ld.so.preload
    fi
    %__rm -f $tmpfile
fi
%post_ldconfig_sys

%preun
if [ -f %_sysconfdir/ld.so.preload ]; then
    tmpfile=`mktemp -t %name.XXXXXX` || exit 1
    if %__grep -q %name %_sysconfdir/ld.so.preload 2>/dev/null; then
        /bin/echo "Removing %name from %_sysconfdir/ld.so.preload"
        %__cp %_sysconfdir/ld.so.preload $tmpfile
        %__grep -v %name $tmpfile > %_sysconfdir/ld.so.preload
    fi
    %__rm -f $tmpfile
fi

%postun
%postun_ldconfig

%changelog
* Tue Nov 04 2003 Serhii Hlodin <hlodin@altlinux.ru> 2.0.16-alt2
- Minor fixes in spec

* Sun May 18 2003 Serhii Hlodin <hlodin@altlinux.ru> 2.0.16-alt1
- Initial build based on original spec-file

